<?php

// Only allow loading from inside WordPress.
defined('ABSPATH') || exit;

function ncms_after_setup_theme() {
    add_theme_support('html5', array('search-form'));
    add_theme_support('align-wide');
    add_theme_support('automatic-feed-links');
    add_theme_support('title-tag');
    add_theme_support('responsive-embeds');
    add_theme_support('post-thumbnails');
    add_editor_style();

    register_post_meta('', 'ncms_header_html', array(
        'show_in_rest' => true,
        'single' => true,
        'type' => 'string',
    ));

    register_post_meta('', 'ncms_sidebar', array(
        'show_in_rest' => true,
        'single' => true,
        'type' => 'string',
        'sanitize_callback' => 'ncms_sanitize_sidebar'
    ));

    register_post_meta('kb', 'ncms_kb_id', array(
        'show_in_rest' => true,
        'single' => true,
        'type' => 'integer'
    ));

    register_post_meta('den_extension', 'ncms_docs_url', array(
        'show_in_rest' => true,
        'single' => true,
        'type' => 'string'
    ));

    add_theme_support('editor-color-palette', array(
        array(
            'name' => __('Default Dark Blue', 'ncms'),
            'slug' => 'dark-blue',
            'color' => '#282B3A',
        ),
        array(
            'name' => __('Inedo Blue 1', 'ncms'),
            'slug' => 'inedo-blue-1',
            'color' => '#025291',
        ),
        array(
            'name' => __('Inedo Blue 2', 'ncms'),
            'slug' => 'inedo-blue-2',
            'color' => '#194073',
        ),
        array(
            'name' => __('Inedo Blue 3', 'ncms'),
            'slug' => 'inedo-blue-3',
            'color' => '#152C53',
        ),
        array(
            'name' => __('ProGet Blue 1', 'ncms'),
            'slug' => 'proget-blue-1',
            'color' => '#79BFF2',
        ),
        array(
            'name' => __('ProGet Blue 2', 'ncms'),
            'slug' => 'proget-blue-2',
            'color' => '#37BBF7',
        ),
        array(
            'name' => __('ProGet Blue 3', 'ncms'),
            'slug' => 'proget-blue-3',
            'color' => '#3FA9F5',
        ),
        array(
            'name' => __('ProGet Blue 4', 'ncms'),
            'slug' => 'proget-blue-4',
            'color' => '#1696F0',
        ),
        array(
            'name' => __('Hedgehog Green 1', 'ncms'),
            'slug' => 'hedgehog-green-1',
            'color' => '#43B3AB',
        ),
        array(
            'name' => __('Hedgehog Green 2', 'ncms'),
            'slug' => 'hedgehog-green-2',
            'color' => '#45B886',
        ),
        array(
            'name' => __('Hedgehog Green 3', 'ncms'),
            'slug' => 'hedgehog-green-3',
            'color' => '#4FB864',
        ),
        array(
            'name' => __('Otter Purple 1', 'ncms'),
            'slug' => 'otter-purple-1',
            'color' => '#9263AB',
        ),
        array(
            'name' => __('Otter Purple 2', 'ncms'),
            'slug' => 'otter-purple-2',
            'color' => '#925091',
        ),
        array(
            'name' => __('Otter Purple 3', 'ncms'),
            'slug' => 'otter-purple-3',
            'color' => '#943B79',
        ),
        array(
            'name' => __('Otter Purple 4', 'ncms'),
            'slug' => 'otter-purple-4',
            'color' => '#852F65',
        ),
        array(
            'name' => __('BuildMaster Orange 1', 'ncms'),
            'slug' => 'buildmaster-orange-1',
            'color' => '#F6A52B',
        ),
        array(
            'name' => __('BuildMaster Orange 2', 'ncms'),
            'slug' => 'buildmaster-orange-2',
            'color' => '#F48C29',
        ),
        array(
            'name' => __('BuildMaster Orange 3', 'ncms'),
            'slug' => 'buildmaster-orange-3',
            'color' => '#F37326',
        ),
        array(
            'name' => __('BuildMaster Orange 4', 'ncms'),
            'slug' => 'buildmaster-orange-4',
            'color' => '#F15A24',
        ),
        array(
            'name' => __('UPack Gray 1', 'ncms'),
            'slug' => 'upack-gray-1',
            'color' => '#B8B9C1',
        ),
        array(
            'name' => __('UPack Gray 2', 'ncms'),
            'slug' => 'upack-gray-2',
            'color' => '#8689A1',
        ),
        array(
            'name' => __('Romp Pink 1', 'ncms'),
            'slug' => 'romp-pink-1',
            'color' => '#F22C8F',
        ),
        array(
            'name' => __('Romp Pink 2', 'ncms'),
            'slug' => 'romp-pink-2',
            'color' => '#CB1462',
        ),
        array(
            'name' => __('White', 'ncms'),
            'slug' => 'inedo-white',
            'color' => '#FFFFFF',
        ),
        array(
            'name' => __('Light Grey', 'ncms'),
            'slug' => 'inedo-lightgrey',
            'color' => '#F6F6F6',
        ),
        array(
            'name' => __('Steel Blue', 'ncms'),
            'slug' => 'inedo-steel-blue',
            'color' => '#48729D',
        )
    ));

    register_nav_menus(
        array(
            'mini-nav' => __('Mini-Nav', 'ncms'),
            'navigation' => __('Navigation', 'ncms'),
            'mini-nav-jp' => __('Mini-Nav-JP', 'ncms'),
            'navigation-jp' => __('Navigation-JP', 'ncms'),
            'mini-nav-codex' => __('Mini-Nav-Codex', 'ncms'),
            'navigation-codex' => __('Navigation-Codex', 'ncms')        )
    );
}
add_action('after_setup_theme', 'ncms_after_setup_theme');
function linked_url() {
    add_menu_page( 'linked_url', 'Reusable Blocks', 'read', 'edit.php?post_type=wp_block', '', 'dashicons-editor-table', 22 );
}
add_action( 'admin_menu', 'linked_url' );

function ncms_admin_init() {    
    register_setting('general', 'ncms_gse_id');
    register_setting('general', 'ncms_gps_api_key');
 
    add_settings_section(
        'ncms_settings_section',
        'NCMS Settings', 'ncms_settings_section_callback',
        'general'
    );
 
    add_settings_field(
        'ncms_gse_id_field',
        'Google Search Engine ID', 'ncms_gse_id_field_callback',
        'general',
        'ncms_settings_section'
    );

    add_settings_field(
      'ncms_gps_api_key_field',
      'Google Programmable Search API Key', 'ncms_gps_api_key_field_callback',
      'general',
      'ncms_settings_section'
  );
}
function ncms_settings_section_callback() {
}

function ncms_gse_id_field_callback() {
  $gse_id = get_option('ncms_gse_id');
  ?>
  <input type="text" name="ncms_gse_id" value="<?php echo isset( $gse_id ) ? esc_attr( $gse_id ) : ''; ?>">
  <?php
}
function ncms_gps_api_key_field_callback() {
  $gps_api_key = get_option('ncms_gps_api_key');
  ?>
  <input type="text" name="ncms_gps_api_key" value="<?php echo isset( $gps_api_key ) ? esc_attr( $gps_api_key ) : ''; ?>">
  <?php
}
add_action('admin_init', 'ncms_admin_init');

require_once dirname(__FILE__) . '/_redirects.php';

function ncms_sanitize_sidebar($value, $key, $type) {
    if (!in_array($value, array(
        '',
        'buildmaster',
        'company',
        'general',
        'otter',
        'proget',
        'romp',
        'support',
        'training',
        'upack'
    ))) {
        return '';
    }

    return $value;
}

function ncms_query_vars($vars) {
    $vars[] = 'kb_id';
    return $vars;
}
add_filter('query_vars', 'ncms_query_vars');

function ncms_parse_query($query) {
    if (isset($query->query_vars['post_type']) && $query->query_vars['post_type'] == 'kb' && !empty($query->query_vars['kb_id']) && empty($query->query_vars['name'])) {
        $page_id = (new WP_Query(array(
            'post_type' => 'kb',
            'meta_key' => 'ncms_kb_id',
            'meta_query' => array(
                array(
                    'key' => 'ncms_kb_id',
                    'value' => $query->query_vars['kb_id']
                )
            ),
            'fields' => 'ids'
        )))->get_posts();
        if (count($page_id)) {
            $query->query(array(
                'post_type' => 'kb',
                'p' => $page_id[0]
            ));
        } else {
            $query->query(array(
                'post_type' => 'kb',
                'p' => -1
            ));
        }
    }
}
add_action('parse_query', 'ncms_parse_query');

function ncms_late_init() {
    wp_register_script(
        'ncms-blocks',
        get_template_directory_uri() . '/blocks.js',
        array('wp-blocks', 'wp-block-editor', 'wp-element', 'wp-components')
    );
    wp_register_script(
        'ncms-codex-blocks',
        get_template_directory_uri() . '/codex-blocks.js',
        array('wp-blocks', 'wp-editor', 'wp-element', 'wp-components')
    );
    wp_register_style(
        'ncms-codex-blocks',
	get_template_directory_uri() . '/codex-blocks.css'
    );
    wp_register_style(
        'inedo-product-templates',
        '/resources/styles/product-templates.css'
    );
    wp_register_style(
        'inedo-training-template',
        '/resources/styles/training-template.css'
    );
    wp_register_script(
        'inedo-product-helpers',
        get_template_directory_uri() . '/product-helpers.js',
        array('jquery')
    );
    wp_register_style(
        'inedo-jp',
        '/jp/styles/styles-main.css'
    );
    wp_register_style(
        'inedo-tutorial',
        '/support/tutorials/_resources/tutorial.css'
    );
    wp_register_style(
        'inedo-den-all-items',
        '/den/all-items.css'
    );
    wp_register_style(
        'inedo-den-extension-test',
        '/den/extension-test.css'
    );
    register_block_type('ncms/header-html', array(
        'editor_script' => 'ncms-blocks',
    ));
    register_block_type('ncms/sidebar', array(
        'editor_script' => 'ncms-blocks',
    ));
    register_block_type('ncms/kb-id', array(
        'editor_script' => 'ncms-blocks',
    ));
    register_block_type('ncms/source-code-link', array(
        'editor_script' => 'ncms-blocks',
    ));
    register_block_type('inedo/page-banner', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/key-points', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/inedo-link-block', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/page-split-content', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/slider', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/slider-item', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/more-content', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/boxes', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/box', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/hubspot-form', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/inedo-button', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/inedo-wizard-button', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/notification', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/toolchain', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/pricing', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    register_block_type('inedo/product-downloads', array(
        'editor_script' => 'ncms-codex-blocks',
        'editor_style' => 'ncms-codex-blocks',
    ));
    wp_register_style(
        'ncms-bootstrap',
        get_template_directory_uri() . '/bootstrap.min.css'
    );
    wp_register_style(
        'ncms-codex',
        get_template_directory_uri() . '/codex.css',
        array('ncms-bootstrap')
    );
    wp_register_script(
        'ncms-popper',
        get_template_directory_uri() . '/popper.min.js',
        array('jquery')
    );
    wp_register_script(
        'ncms-bootstrap',
        get_template_directory_uri() . '/bootstrap.min.js',
        array('ncms-popper')
    );

    register_taxonomy_for_object_type('post_tag', 'page');
    $page_type_object = get_post_type_object('page');
    $page_type_object->template = array(
        array('ncms/sidebar', array()),
        array('ncms/header-html', array(
            'placeholder' => 'Head Content'
        )),
        array('core/html', array(
            'placeholder' => 'Body Content'
        )),
    );

    add_rewrite_tag('%kb_id%', '([0-9]+)', 'post_type=kb&kb_id=');
    register_post_type('kb', array(
        'label' => 'Knowledge Base',
        'public' => true,
        'show_in_rest' => true,
        'supports' => array('title', 'editor', 'revisions', 'author', 'excerpt', 'page-attributes', 'thumbnail', 'custom-fields'),
        'has_archive' => 'support/kb',
        'menu_icon' => 'dashicons-book',
        'rewrite' => array(
            'slug' => 'support/kb/%kb_id%',
            'paged' => false
        ),
        'taxonomies' => array('post_tag'),
        'template' => array(
            array('ncms/kb-id', array()),
            array('ncms/header-html', array(
                'placeholder' => 'Head Content'
            )),
            array('core/html', array(
                'placeholder' => 'Body Content'
            )),
        )
    ));

    register_post_type('den_extension', array(
        'label' => 'Den Extensions',
        'public' => true,
        'show_in_rest' => true,
        'supports' => array('title', 'editor', 'revisions', 'author', 'excerpt', 'page-attributes', 'thumbnail', 'custom-fields'),
        'has_archive' => 'den/all-items',
        'menu_icon' => 'dashicons-store',
        'rewrite' => array(
            'slug' => 'den',
            'paged' => false
        ),
        'taxonomies' => array('post_tag'),
        'template' => array(
            array('core/paragraph', array(
                'placeholder' => 'Short Description'
            )),
            array('ncms/docs-url', array()),
        )
    ));
    add_rewrite_rule('den/tag/([^/]+)$', 'index.php?post_type=den_extension&tag=$matches[1]', 'top');
}

add_action('init', 'ncms_late_init');

function ncms_admin_head() {
?>
<style>.fixed .column-kb_id { width: 8% }</style>
<?php
}
add_action('admin_head', 'ncms_admin_head');

function ncms_kb_permalink($permalink, $post) {
    if (strpos($permalink, '%kb_id%') !== false) {
        $permalink = str_replace('%kb_id%', get_post_meta($post->ID, 'ncms_kb_id', true), $permalink);
    }

    return $permalink;
}
add_filter('post_type_link', 'ncms_kb_permalink', 10, 2);

function ncms_mime_types($types) {
    $types['svg'] = 'image/svg+xml';

    return $types;
}
add_filter('mime_types', 'ncms_mime_types');

function ncms_fix_mime_types($data, $file, $filename, $mimes) {
    $wp_filetype = wp_check_filetype($filename, $mimes);

    $ext = $wp_filetype['ext'];
    $type = $wp_filetype['type'];
    $proper_filename = $data['proper_filename'];

    return compact('ext', 'type', 'proper_filename');
}

add_filter('wp_check_filetype_and_ext', 'ncms_fix_mime_types', 10, 4);

function ncms_header_html() {
    if (is_singular()) {
        echo get_post_meta(get_the_ID(), 'ncms_header_html', true);
    }
}
add_action('wp_head', 'ncms_header_html');

function ncms_allow_many_redirects($limit) {
    return 10000000;
}
add_filter('srm_max_redirects', 'ncms_allow_many_redirects');

function ncms_add_kb_columns($columns) {
    return array_slice($columns, 0, 1, true) +
        array('kb_id' => 'KB #') +
        array_slice($columns, 1, null, true);
}
add_filter('manage_kb_posts_columns', 'ncms_add_kb_columns');

function ncms_add_kb_sortable($sortable) {
    $sortable['kb_id'] = 'ncms_kb_id';
    return $sortable;
}
add_filter('manage_edit-kb_sortable_columns', 'ncms_add_kb_sortable');

function ncms_kb_orderby($query) {
    if ($query->get('orderby') == 'ncms_kb_id') {
        $query->set('meta_key', 'ncms_kb_id');
        $query->set('orderby', 'meta_value_num');
    }
}
add_action('pre_get_posts', 'ncms_kb_orderby');

function ncms_kb_column_data($column, $post_id) {
    switch ($column) {
        case 'kb_id':
            echo get_post_meta($post_id, 'ncms_kb_id', true);
            break;
    }
}
add_action('manage_kb_posts_custom_column' , 'ncms_kb_column_data', 10, 2);

function ncms_redirect_canonical($redirect_url, $requested_url) {
    // disable 404 guessing based on last component
    return is_404() ? false : $redirect_url;
}
add_filter('redirect_canonical', 'ncms_redirect_canonical', 10, 2);

function ncms_redirect_noquery($url) {
    if (strpos($url, '?') !== false) {
        list($url, $query) = explode('?', $url);
    }
    return $url;
}
add_filter('srm_requested_path', 'ncms_redirect_noquery');

function ncms_search_header($archive_name, $plural_object_name) {
?>
    <div class="content-container">
        <div class="content large-search" id="search-area">
            <form action="" method="get">
                <input type="search" name="s" placeholder="Search <?php echo $archive_name; ?>..." value="<?php echo get_search_query(); ?>">
		<input type="submit" value="Search">
            </form>

<?php if (is_search()): ?>
            <h2><?php echo $plural_object_name; ?> for &ldquo;<?php echo get_search_query(); ?>&rdquo;</h2>
            <div class="found-results-count"><?php

global $wp_query;
$result_count = $wp_query->found_posts;
printf(_n('Found %1$s result.', 'Found %1$s results.', $result_count, 'ncms'), number_format_i18n($result_count));

?></div>
<?php else: ?>
            <h2>All <?php echo $plural_object_name; ?></h2>
<?php endif; ?>
        </div>
    </div>
<?php
}

function create_gse_query($query, $start) {
  $url = 'https://www.googleapis.com/customsearch/v1/siterestrict?';
  $arguments = array(
      'key'  => get_option('ncms_gps_api_key'),
      'cx'  => get_option('ncms_gse_id'),
      'q'=> urlencode($query),
      'start' => $start
  );
  $url_parameters = array();
  foreach ($arguments as $key => $value){
      $url_parameters[] = $key.'='.$value;
  }
  return $url.implode('&', $url_parameters);  
}

function ncms_bootstrap_nav_item($classes, $item, $args, $depth) {
	if ($args->menu_class == 'navbar-nav') {
		$classes[] = 'nav-item';
		if ($item->current) {
			$classes[] = 'active';
		}
	}
	return $classes;
}
add_filter('nav_menu_css_class', 'ncms_bootstrap_nav_item', 10, 4);

function ncms_bootstrap_nav_link($atts, $item, $args, $depth) {
	if ($args->menu_class == 'navbar-nav') {
		$atts['class'] = 'nav-link';
	}
	return $atts;
}
add_filter('nav_menu_link_attributes', 'ncms_bootstrap_nav_link', 10, 4);

function ncms_bootstrap_nav_submenu($classes) {
	if ($args->menu_class == 'navbar-nav') {
		$classes[] = 'dropdown-menu';
	}
	return $classes;
}
add_filter('nav_menu_submenu_css_class', 'ncms_bootstrap_nav_submenu', 10, 2);

// codex max mega menu theme

function megamenu_add_theme_codex_1581452583($themes) {
    $themes["codex_1581452583"] = array(
        'title' => 'codex',
        'container_background_from' => 'rgb(255, 255, 255)',
        'container_background_to' => 'rgb(255, 255, 255)',
        'menu_item_background_hover_from' => 'rgb(255, 255, 255)',
        'menu_item_background_hover_to' => 'rgb(255, 255, 255)',
        'menu_item_link_font_size' => '16px',
        'menu_item_link_color' => 'rgb(40, 43, 58)',
        'menu_item_link_weight' => 'bold',
        'menu_item_link_text_transform' => 'uppercase',
        'menu_item_link_color_hover' => 'rgb(46, 48, 56)',
        'menu_item_link_weight_hover' => 'bold',
        'panel_background_from' => 'rgb(255, 255, 255)',
        'panel_background_to' => 'rgb(255, 255, 255)',
        'panel_width' => '#mega-menu-wrap-navigation',
        'panel_border_color' => 'rgb(142, 142, 142)',
        'panel_header_color' => 'rgb(142, 142, 142)',
        'panel_font_size' => '16px',
        'panel_font_color' => 'rgb(255, 255, 255)',
        'panel_font_family' => 'inherit',
        'panel_second_level_font_color' => 'rgb(142, 142, 142)',
        'panel_second_level_font_color_hover' => 'rgb(40, 43, 58)',
        'panel_second_level_text_transform' => 'uppercase',
        'panel_second_level_font' => 'inherit',
        'panel_second_level_font_size' => '16px',
        'panel_second_level_font_weight' => 'bold',
        'panel_second_level_font_weight_hover' => 'bold',
        'panel_second_level_text_decoration' => 'none',
        'panel_second_level_text_decoration_hover' => 'none',
        'panel_third_level_font_color' => 'rgb(142, 142, 142)',
        'panel_third_level_font_color_hover' => 'rgb(40, 43, 58)',
        'panel_third_level_font' => 'inherit',
        'panel_third_level_font_size' => '14px',
        'flyout_width' => 'auto',
        'flyout_menu_background_from' => 'rgb(255, 255, 255)',
        'flyout_menu_background_to' => 'rgb(255, 255, 255)',
        'flyout_background_from' => 'rgb(255, 255, 255)',
        'flyout_background_to' => 'rgb(255, 255, 255)',
        'flyout_background_hover_from' => 'rgb(255, 255, 255)',
        'flyout_background_hover_to' => 'rgb(255, 255, 255)',
        'flyout_link_size' => '14px',
        'flyout_link_color' => 'rgb(142, 142, 142)',
        'flyout_link_color_hover' => 'rgb(40, 43, 58)',
        'flyout_link_family' => 'inherit',
        'responsive_breakpoint' => '992px',
        'transitions' => 'on',
        'toggle_background_from' => 'rgb(255, 255, 255)',
        'toggle_background_to' => 'rgb(255, 255, 255)',
        'mobile_menu_padding_top' => '15px',
        'mobile_background_from' => 'rgb(255, 255, 255)',
        'mobile_background_to' => 'rgb(255, 255, 255)',
        'mobile_menu_item_link_font_size' => '16px',
        'mobile_menu_item_link_color' => 'rgb(142, 142, 142)',
        'mobile_menu_item_link_text_align' => 'left',
        'mobile_menu_item_link_color_hover' => 'rgb(40, 43, 58)',
        'mobile_menu_item_background_hover_from' => 'rgb(255, 255, 255)',
        'mobile_menu_item_background_hover_to' => 'rgb(255, 255, 255)',
        'custom_css' => '/** Push menu onto new line **/ 
#{$wrap} { 
    clear: both; 
}

@include desktop {
    #{$wrap} #{$menu} > .mega-menu-item > .mega-sub-menu {
        box-shadow: 5px 5px 5px #c6c5c5;
    }
	
	 #{$wrap} #{$menu} .mega-menu-item.mega-menu-flyout .mega-sub-menu {
        box-shadow: 5px 5px 5px #c6c5c5;
    }

    #{$wrap} #{$menu} > li.mega-menu-item > a.mega-menu-link {
        padding-right: 30px;
    }
}

@include mobile {
	.navbar-collapse {
        /* flex-basis: 0;*/
        flex-grow: 1;
	}
	.navbar-brand {
        position: absolute;
		z-index: 200;
		top: 15px;
	}
}

',
    );
    return $themes;
}
add_filter("megamenu_themes", "megamenu_add_theme_codex_1581452583");

function megamenu_add_theme_codex_legacy_1584379301($themes) {
    $themes["codex-legacy_1584379301"] = array(
        'title' => 'codex-legacy',
        'container_background_from' => 'rgb(255, 255, 255)',
        'container_background_to' => 'rgb(255, 255, 255)',
        'menu_item_background_hover_from' => 'rgb(255, 255, 255)',
        'menu_item_background_hover_to' => 'rgb(255, 255, 255)',
        'menu_item_link_font_size' => '16px',
        'menu_item_link_color' => 'rgb(40, 43, 58)',
        'menu_item_link_weight' => 'bold',
        'menu_item_link_text_transform' => 'uppercase',
        'menu_item_link_color_hover' => 'rgb(46, 48, 56)',
        'menu_item_link_weight_hover' => 'bold',
        'panel_background_from' => 'rgb(255, 255, 255)',
        'panel_background_to' => 'rgb(255, 255, 255)',
        'panel_width' => '#mega-menu-wrap-navigation',
        'panel_border_color' => 'rgb(142, 142, 142)',
        'panel_header_color' => 'rgb(142, 142, 142)',
        'panel_font_size' => '16px',
        'panel_font_color' => 'rgb(255, 255, 255)',
        'panel_font_family' => 'inherit',
        'panel_second_level_font_color' => 'rgb(142, 142, 142)',
        'panel_second_level_font_color_hover' => 'rgb(40, 43, 58)',
        'panel_second_level_text_transform' => 'uppercase',
        'panel_second_level_font' => 'inherit',
        'panel_second_level_font_size' => '16px',
        'panel_second_level_font_weight' => 'bold',
        'panel_second_level_font_weight_hover' => 'bold',
        'panel_second_level_text_decoration' => 'none',
        'panel_second_level_text_decoration_hover' => 'none',
        'panel_third_level_font_color' => 'rgb(142, 142, 142)',
        'panel_third_level_font_color_hover' => 'rgb(40, 43, 58)',
        'panel_third_level_font' => 'inherit',
        'panel_third_level_font_size' => '14px',
        'flyout_width' => 'auto',
        'flyout_menu_background_from' => 'rgb(255, 255, 255)',
        'flyout_menu_background_to' => 'rgb(255, 255, 255)',
        'flyout_background_from' => 'rgb(255, 255, 255)',
        'flyout_background_to' => 'rgb(255, 255, 255)',
        'flyout_background_hover_from' => 'rgb(255, 255, 255)',
        'flyout_background_hover_to' => 'rgb(255, 255, 255)',
        'flyout_link_size' => '14px',
        'flyout_link_color' => 'rgb(142, 142, 142)',
        'flyout_link_color_hover' => 'rgb(40, 43, 58)',
        'flyout_link_family' => 'inherit',
        'responsive_breakpoint' => '0px',
        'transitions' => 'on',
        'toggle_background_from' => 'rgb(255, 255, 255)',
        'toggle_background_to' => 'rgb(255, 255, 255)',
        'mobile_menu_padding_top' => '15px',
        'mobile_background_from' => 'rgb(255, 255, 255)',
        'mobile_background_to' => 'rgb(255, 255, 255)',
        'mobile_menu_item_link_font_size' => '16px',
        'mobile_menu_item_link_color' => 'rgb(142, 142, 142)',
        'mobile_menu_item_link_text_align' => 'left',
        'mobile_menu_item_link_color_hover' => 'rgb(40, 43, 58)',
        'mobile_menu_item_background_hover_from' => 'rgb(255, 255, 255)',
        'mobile_menu_item_background_hover_to' => 'rgb(255, 255, 255)',
        'custom_css' => '/** Push menu onto new line **/ 
        #{$wrap} { 
            clear: both; 
        }
        
        @include desktop {
            #{$wrap} #{$menu} > .mega-menu-item > .mega-sub-menu {
                box-shadow: 5px 5px 5px #c6c5c5;
            }
            
             #{$wrap} #{$menu} .mega-menu-item.mega-menu-flyout .mega-sub-menu {
                box-shadow: 5px 5px 5px #c6c5c5;
            }

            #{$wrap} #{$menu} > li.mega-menu-item > a.mega-menu-link {
                padding-right: 30px;
            }
            
            .navbar-collapse.navbar-collapse-legacy {
                /* flex-basis: 0;*/
                flex-basis: auto;
                flex-grow: 1;
                justify-content: flex-end;
            }
            
            @media (max-width: 992px) {
                .navbar-collapse.navbar-collapse-legacy {
                    /* flex-basis: 0;*/
                    flex-basis: auto;
                    flex-grow: 0;
                    justify-content: flex-end;                    
				
                    #{$wrap} #{$menu} > li.mega-menu-item > a.mega-menu-link {
                        padding-right: 10px;
                    }
                }
            }
            
            
            
            @media (min-width: 576px) and (max-width: 993px) {
                .container.container-legacy {
                    min-width: 100%;
                }
            }
            
            .navbar-brand.navbar-brand-legacy {        
                position: static !important;
                z-index: auto;
                top: 15px;
            }
        }
        
        @include mobile {
            .navbar-collapse.navbar-collapse-legacy {
                /* flex-basis: 0;*/
                flex-basis: auto;
                flex-grow: 0;
                justify-content: flex-end;
            }
            .navbar-brand.navbar-brand-legacy {        
                position: static;
                z-index: auto;
                top: 15px;
            }
        }

',
    );
    return $themes;
}
add_filter("megamenu_themes", "megamenu_add_theme_codex_legacy_1584379301");

function megamenu_override_default_theme($value) {
    // change 'primary' to your menu location ID
    if ( !isset($value['navigation-codex']['theme']) ) {
      $value['navigation-codex']['theme'] = 'codex_1581452583'; // change my_custom_theme_key to the ID of your exported theme
    }

    if ( !isset($value['navigation']['theme']) ) {
        $value['navigation']['theme'] = 'codex-legacy_1584379301'; // change my_custom_theme_key to the ID of your exported theme
      }
  
    return $value;
  }

  add_filter('default_option_megamenu_settings', 'megamenu_override_default_theme');
