<?php

get_header('content');

$search_query = sanitize_text_field($_GET['s']);
$start = 1;
if (isset($_GET['start']))
{ 
  $start = $_GET['start'];
}

$url = create_gse_query($search_query, $start);
$response = file_get_contents($url);
if ($response) {
  $json = json_decode($response,true);
  $items = $json['items'];
  $result_count = $json['searchInformation']['totalResults'];

  $next_index = $json['queries']['nextPage'][0]['startIndex'];
  $next_url = "index.php?s=".$search_query."&start=".$next_index;

  $previous_index = $json['queries']['previousPage'][0]['startIndex'];
  if ($previous_index)
  {
    $previous_url = "index.php?s=".$search_query."&start=".$previous_index;
  }
}else{
  $result_count = 0;
}

?>
    <div class="content-container">
        <div class="content large-search" id="search-area">
            <form action="" method="get">
                <input type="search" name="s" placeholder="Search Inedo.com..." value="<?php echo $search_query; ?>">
		<input type="submit" value="Search">
            </form>

<?php if (is_search()): ?>
            <h2><?php echo 'Search results'; ?> for &ldquo;<?php echo $search_query; ?>&rdquo;</h2>
            <div class="found-results-count"><?php

printf(_n('Found %1$s result.', 'Found %1$s results.', $result_count, 'ncms'), number_format_i18n($result_count));

?></div>
<?php else: ?>
            <h2>All <?php echo 'Search results'; ?></h2>
<?php endif; ?>
        </div>
    </div>
<?php

if ($items) {
  foreach ($items as $item)
  {
?>
    <article <?php post_class('search-result'); ?>>
        <h3><a href="<?= $item['link'] ?>"><?= $item['title'] ?></a></h3>
        <?= $item['htmlSnippet'] ?>
    </article>
<?php
  }
?>

<div id="search-pagination">

<?php
  if ($previous_url)
  {
?>
    <a href="<?= $previous_url ?>">&lt; Previous Page</a>
<?php
  } else {
?>
    <span>&lt; Previous Page</span>
<?php
  }
?> - <?php

  if ($next_url)
  {
?>
    <a href="<?= $next_url ?>">Next Page &gt;</a>
<?php
  } else {
?>
    <span>Next Page &gt;</span>
<?php    
  }
?>
</div>

<?php
}

get_footer('content');
